import '@things-factory/form-ui'
import '@things-factory/grist-ui'
import '../inventory/inventory-by-product-detail'

import gql from 'graphql-tag'
import { css, html } from 'lit-element'
import { connect } from 'pwa-helpers/connect-mixin'

import { i18next, localize } from '@things-factory/i18n-base'
import { client, gqlContext, PageView, store } from '@things-factory/shell'
import { flattenObject, isMobileDevice } from '@things-factory/utils'
import { CONDITION_OF_GOODS } from '../constants/order'

function formatLocalDate(date = new Date()) {
  const year = date.getFullYear()
  const month = String(date.getMonth() + 1).padStart(2, '0')
  const day = String(date.getDate()).padStart(2, '0')
  return `${year}-${month}-${day}`
}

class InboundOrderDetailsReport extends connect(store)(localize(i18next)(PageView)) {
  static get styles() {
    return css`
      :host {
        display: flex;
        flex-direction: column;
        width: 100%;
      }

      data-grist {
        overflow-y: auto;
        flex: 1;
      }

      .summary {
        background-color: var(--main-section-background-color);
        display: flex;
        flex-direction: column;
        overflow-y: auto;
        align-items: flex-end;
        padding: var(--data-list-item-padding);
        display: grid;
        font-size: 14px;
        color: #394e64;
        grid-template-columns: repeat(2, 1fr);
        grid-auto-rows: minmax(24px, auto);
      }
    `
  }

  static get properties() {
    return {
      _searchFields: Object,
      _config: Object,
      _partners: Object,
      _gristData: Object,
      data: Object
    }
  }

  get context() {
    return {
      title: i18next.t('title.inbound_order_details_report'),
      exportable: {
        name: i18next.t('title.inbound_order_details_report'),
        data: this._exportableData.bind(this)
      },
      help: 'operato-wms/report/inbound-order-details-report'
    }
  }

  get dataGrist() {
    return this.shadowRoot.querySelector('data-grist')
  }

  get searchForm() {
    return this.shadowRoot.querySelector('search-form')
  }

  get _bizplaceSelector() {
    return this.searchForm.shadowRoot.querySelector('select[name=bizplace]')
  }

  get _fromDateInput() {
    return this.searchForm.shadowRoot.querySelector('input[name=fromDate]')
  }

  get _toDateInput() {
    return this.searchForm.shadowRoot.querySelector('input[name=toDate]')
  }

  render() {
    return html`
      <search-form id="search-form" .fields=${this._searchFields} @submit=${e => this.dataGrist.fetch()}></search-form>

      <data-grist
        .mode=${isMobileDevice() ? 'LIST' : 'GRID'}
        .config=${this._config}
        .fetchHandler="${this.fetchHandler.bind(this)}"
      ></data-grist>
    `
  }

  get searchFields() {
    return [
      {
        label: i18next.t('field.company'),
        name: 'bizplace',
        type: 'select',
        options: [
          { value: '' },
          ...this._partners
            .map(partner => {
              return {
                name: `${partner.name} ${partner.description ? `(${partner.description})` : ''}`,
                value: partner.id
              }
            })
            .sort(this._compareValues('name', 'asc'))
        ],
        props: { searchOper: 'eq' }
      },
      {
        label: i18next.t('field.from_date'),
        name: 'fromDate',
        type: 'date',
        props: {
          searchOper: 'eq',
          max: formatLocalDate(new Date())
        },
        value: (() => {
          const date = new Date()
          date.setMonth(date.getMonth() - 1)
          return formatLocalDate(date)
        })(),
        handlers: { change: this._modifyDateRange.bind(this) }
      },
      {
        label: i18next.t('field.to_date'),
        name: 'toDate',
        type: 'date',
        props: {
          searchOper: 'eq',
          min: (() => {
            const date = new Date()
            date.setMonth(date.getMonth() - 1)
            return formatLocalDate(date)
          })(),
          max: (() => {
            const max = new Date()
            return formatLocalDate(max)
          })()
        },
        value: formatLocalDate(new Date()),
        handlers: { change: this._submit.bind(this) }
      },
      {
        label: i18next.t('field.product_info'),
        name: 'product',
        type: 'string',
        props: { searchOper: 'in' }
      },
      {
        label: i18next.t('field.gan_no'),
        name: 'ganNo',
        type: 'text',
        props: { searchOper: 'custom' }
      },
      {
        label: i18next.t('field.grn_no'),
        name: 'grnNo',
        type: 'text',
        props: { searchOper: 'custom' }
      },
      {
        label: i18next.t('field.po_no'),
        name: 'poNo',
        type: 'text',
        props: { searchOper: 'custom' }
      },
      {
        label: i18next.t('field.do_no'),
        name: 'doNo',
        type: 'text',
        props: { searchOper: 'custom' }
      },
      {
        label: i18next.t('field.carton_id'),
        name: 'cartonId',
        type: 'text',
        props: { searchOper: 'custom' }
      },
      {
        label: i18next.t('field.lot_id'),
        name: 'palletId',
        type: 'text',
        props: { searchOper: 'custom' }
      },
      {
        label: i18next.t('field.by_unload_complete'),
        name: 'byUnloadComplete',
        type: 'checkbox',
        props: { searchOper: 'eq' }
      }
    ]
  }

  get reportConfig() {
    let rows = {
      selectable: false,
      insertable: false,
      appendable: false
    }
    let columns = [
      { type: 'gutter', gutterName: 'sequence' },
      {
        type: 'string',
        name: 'bizplace|name',
        header: i18next.t('field.company'),
        width: 200
      },
      {
        type: 'string',
        name: 'ganNo',
        header: i18next.t('field.gan_no'),
        width: 200
      },
      {
        type: 'string',
        name: 'grnNo',
        header: i18next.t('field.grn_no'),
        width: 200
      },
      {
        type: 'string',
        name: 'deliveryOrderNo',
        header: i18next.t('field.do_no'),
        width: 200
      },
      {
        type: 'string',
        name: 'purchaseOrderNo',
        header: i18next.t('field.po_no'),
        width: 200
      },
      {
        type: 'string',
        name: 'contactPoint|companyName',
        header: i18next.t('field.supplier'),
        width: 170
      },
      {
        type: 'string',
        name: 'refNo1',
        header: i18next.t('field.ref_no'),
        width: 150
      },
      {
        type: 'string',
        name: 'refNo2',
        header: i18next.t('field.ref_no_2'),
        width: 150
      },
      {
        type: 'string',
        name: 'refNo3',
        header: i18next.t('field.ref_no_3'),
        width: 150
      },
      {
        type: 'boolean',
        name: 'looseItem',
        header: i18next.t('field.loose_item'),
        record: { align: 'center' },
        width: 100
      },
      {
        type: 'string',
        name: 'containerNo',
        header: i18next.t('field.container_no'),
        record: { align: 'center' },
        width: 120
      },
      {
        type: 'number',
        name: 'containerSize',
        header: i18next.t('field.container_size'),
        width: 120
      },
      {
        type: 'boolean',
        name: 'ownTransport',
        header: i18next.t('field.own_transport'),
        record: { align: 'center' },
        width: 120
      },
      {
        type: 'string',
        name: 'orderCreatedBy',
        header: i18next.t('field.order_created_by'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'orderCreatedAt',
        header: i18next.t('field.order_created_at'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'unloadStart',
        header: i18next.t('field.unload_start'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'unloadComplete',
        header: i18next.t('field.unload_complete'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'putawayStart',
        header: i18next.t('field.putaway_start'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'putawayComplete',
        header: i18next.t('field.putaway_complete'),
        width: 170
      },
      {
        type: 'string',
        name: 'acceptedBy',
        header: i18next.t('field.accepted_by'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'acceptedAt',
        header: i18next.t('field.accepted_at'),
        width: 170
      },
      {
        type: 'number',
        name: 'orderLineItem',
        header: i18next.t('field.line_no'),
        width: 80
      },
      {
        type: 'string',
        name: 'product|sku',
        header: i18next.t('field.sku'),
        width: 150
      },
      {
        type: 'string',
        name: 'product|name',
        header: i18next.t('field.product_name'),
        width: 200
      },
      {
        type: 'string',
        name: 'product|description',
        header: i18next.t('field.product_description'),
        width: 300
      },
      {
        type: 'string',
        name: 'product|type',
        header: i18next.t('field.product_type'),
        width: 150
      },
      {
        type: 'string',
        name: 'packType',
        header: i18next.t('field.packing_type'),
        width: 150
      },
      {
        type: 'number',
        name: 'packSize',
        header: i18next.t('field.packing_size'),
        width: 150
      },
      {
        type: 'float',
        name: 'actualPackQty',
        header: i18next.t('field.qty'),
        width: 120
      },
      {
        type: 'float',
        name: 'actualPackUomValue',
        header: i18next.t('field.uom_value'),
        width: 120
      },
      {
        type: 'string',
        name: 'uom',
        header: i18next.t('field.uom'),
        width: 100
      },
      {
        type: 'string',
        name: 'conditionOfGoods',
        header: i18next.t('field.type_of_condition'),
        width: 150
      },
      {
        type: 'string',
        name: 'unitCost',
        header: i18next.t('field.unit_cost'),
        width: 100
      },
      {
        type: 'float',
        name: 'unitVolume',
        header: i18next.t('field.unit_volume'),
        width: 120
      },
      {
        type: 'float',
        name: 'totalVolume',
        header: i18next.t('field.total_volume'),
        width: 120
      },
      {
        type: 'float',
        name: 'unitNettWeight',
        header: i18next.t('field.unit_nett_weight'),
        width: 120
      },
      {
        type: 'float',
        name: 'totalUnitNettWeight',
        header: i18next.t('field.total_unit_nett_weight'),
        width: 120
      },
      {
        type: 'float',
        name: 'unitGrossWeight',
        header: i18next.t('field.unit_gross_weight'),
        width: 120
      },
      {
        type: 'float',
        name: 'totalUnitGrossWeight',
        header: i18next.t('field.total_unit_gross_weight'),
        width: 120
      },
      {
        type: 'string',
        name: 'weightUnit',
        header: i18next.t('field.weight_unit'),
        width: 100
      },
      {
        type: 'string',
        name: 'palletId',
        header: i18next.t('field.lot_id'),
        width: 150
      },
      {
        type: 'string',
        name: 'cartonId',
        header: i18next.t('field.carton_id'),
        width: 150
      },
      {
        type: 'string',
        name: 'batchId',
        header: i18next.t('field.batch_id'),
        width: 150
      },
      {
        type: 'string',
        name: 'batchIdRef',
        header: i18next.t('field.batch_id_ref'),
        width: 150
      },
      {
        type: 'date',
        name: 'expirationDate',
        header: i18next.t('field.exp_date'),
        width: 120
      },
      {
        type: 'date',
        name: 'manufactureDate',
        header: i18next.t('field.manufacture_date'),
        width: 120
      },
      {
        type: 'string',
        name: 'unloadedBy',
        header: i18next.t('field.unloaded_by'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'unloadedAt',
        header: i18next.t('field.unloaded_at'),
        width: 170
      },
      {
        type: 'string',
        name: 'putawayBy',
        header: i18next.t('field.putaway_by'),
        width: 170
      },
      {
        type: 'datetime',
        name: 'putawayAt',
        header: i18next.t('field.putaway_at'),
        width: 170
      }
    ]
    let list = {
      fields: [
        'bizplace|name',
        'ganNo',
        'grnNo',
        'deliveryOrderNo',
        'purchaseOrder|name',
        'contactPoint|companyName',
        'refNo1',
        'refNo2',
        'refNo3',
        'looseItem',
        'containerNo',
        'containerSize',
        'ownTransport',
        'orderCreatedBy',
        'orderCreatedAt',
        'unloadStart',
        'unloadComplete',
        'putawayStart',
        'putawayComplete',
        'acceptedBy',
        'acceptedAt',
        'orderLineItem',
        'product|sku',
        'product|name',
        'product|description',
        'product|type',
        'packType',
        'packSize',
        'qty',
        'uomValue',
        'uom',
        'unitCost',
        'unitVolume',
        'totalVolume',
        'unitNettWeight',
        'totalUnitNettWeight',
        'unitGrossWeight',
        'totalUnitGrossWeight',
        'weightUnit',
        'palletId',
        'cartonId',
        'batchId',
        'batchIdRef',
        'expirationDate',
        'conditionOfGoods',
        'manufactureDate',
        'unloadedBy',
        'unloadedAt',
        'putawayBy',
        'putawayAt'
      ]
    }

    return {
      rows: rows,
      columns: columns,
      list,
      pagination: { limit: 50, pages: [50, 100, 200, 500, 1000] }
    }
  }

  async pageInitialized() {
    this._gristData = { total: 0, totalWithOpeningBalance: 0, records: [] }
    this._products = []
    this._partners = [...(await this._fetchPartners())]
    this._searchFields = this.searchFields
    this._config = this.reportConfig
  }

  async pageUpdated(changes, lifecycle) {
    if (this.active) {
      this.dataGrist.fetch()
    }
  }

  async fetchHandler({ page, limit, sorters = [] }) {
    try {
      this._validate()
      let filters = this.searchForm.queryFilters.map(filter => {
        switch (filter.name) {
          case 'fromDate':
            let fromDt = new Date(filter.value)
            fromDt.setHours(0)
            filter.value = fromDt.toISOString()
            break
          case 'toDate':
            let toDt = new Date(filter.value)
            toDt.setHours(23, 59, 59)
            filter.value = toDt.toISOString()
            break
          default:
            break
        }
        return filter
      })

      const pagination = { page, limit }
      const sortings = sorters

      const response = await client.query({
        query: gql`
          query inboundOrderDetailsReport($filters: [Filter!], $pagination: Pagination, $sortings: [Sorting!]) {
            inboundOrderDetailsReport(filters: $filters, pagination: $pagination, sortings: $sortings) {
              items {
                bizplace {
                  name
                  description
                }
                grnNo
                ganNo
                deliveryOrderNo
                refNo1
                refNo2
                refNo3
                looseItem
                importCargo
                containerNo
                containerSize
                ownTransport
                acceptedBy
                acceptedAt
                orderCreatedBy
                orderCreatedAt
                unloadStart
                unloadComplete
                putawayStart
                putawayComplete
                orderLineItem
                product {
                  sku
                  name
                  description
                  type
                }
                purchaseOrderId
                purchaseOrderNo
                contactPoint {
                  id
                  name
                }
                packType
                packSize
                actualPackQty
                actualPackUomValue
                uom
                unitCost
                unitVolume
                totalVolume
                unitNettWeight
                totalUnitNettWeight
                unitGrossWeight
                totalUnitGrossWeight
                weightUnit
                palletId
                cartonId
                batchId
                batchIdRef
                expirationDate
                conditionOfGoods
                manufactureDate
                unloadedAt
                unloadedBy
                putawayAt
                putawayBy
              }
              total
            }
          }
        `,
        variables: { filters, pagination, sortings },
        context: gqlContext()
      })

      const data = {
        total: response.data.inboundOrderDetailsReport.total,
        records:
          response.data.inboundOrderDetailsReport.items.map(itm => {
            itm = {
              ...itm,
              unitCost: parseFloat(itm.unitCost ? itm.unitCost : 0).toFixed(2),
              conditionOfGoods: this._formatConditionOfGoods(itm.conditionOfGoods)
            }

            return flattenObject({ ...itm, bizplace: { name: `${itm.bizplace.name} ${itm.bizplace.description}` } })
          }) || []
      }

      this._gristData = {
        ...data
      }

      return data
    } catch (e) {
      this._showToast(e)
    }
  }

  async _fetchPartners() {
    const filters = []
    const response = await client.query({
      query: gql`
        query partnersBizplaces($filters: [Filter!]) {
          partnersBizplaces(filters: $filters) {
            items {
              id
              name
              description
            }
          }
        }
      `,
      variables: { filters }
    })

    if (!response.errors) {
      return response.data.partnersBizplaces.items
    }
  }
  _validate() {
    if (!this.searchForm.shadowRoot.querySelector('form').checkValidity())
      throw new Error(i18next.t('text.invalid_form_value'))
    if (!this._bizplaceSelector.value) throw new Error(i18next.t('text.no_company_selected'))
    if (!this._fromDateInput.value) throw new Error(i18next.t('text.from_date_is_empty'))
    if (!this._toDateInput.value) throw new Error(i18next.t('text.to_date_is_empty'))
  }

  _compareValues(key, order = 'asc') {
    return function innerSort(a, b) {
      if (!a.hasOwnProperty(key) || !b.hasOwnProperty(key)) {
        return 0
      }

      const varA = typeof a[key] === 'string' ? a[key].toUpperCase() : a[key]
      const varB = typeof b[key] === 'string' ? b[key].toUpperCase() : b[key]

      let comparison = 0
      if (varA > varB) {
        comparison = 1
      } else if (varA < varB) {
        comparison = -1
      }
      return order === 'desc' ? comparison * -1 : comparison
    }
  }

  _modifyDateRange(e) {
    const fromDate = e.currentTarget.value

    if (this._toDateInput.value < fromDate) this._toDateInput.value = fromDate

    const minDate = new Date(fromDate)
    if (Number.isNaN(minDate.getTime())) return

    const min = formatLocalDate(minDate)
    this._toDateInput.min = min
    this._submit()
  }

  _submit(e) {
    this._config = { ...this.reportConfig }
    this.searchForm.submit()
  }

  async _exportableData() {
    try {
      var headerSetting = [
        { header: i18next.t('field.company'), key: 'bizplace|name', width: 60, type: 'string' },
        { header: i18next.t('field.gan_no'), key: 'ganNo', width: 30, type: 'string' },
        { header: i18next.t('field.grn_no'), key: 'grnNo', width: 30, type: 'string' },
        { header: i18next.t('field.do_no'), key: 'deliveryOrderNo', width: 30, type: 'string' },
        { header: i18next.t('field.po_no'), key: 'purchaseOrder|name', width: 30, type: 'string' },
        { header: i18next.t('field.supplier'), key: 'contactPoint|companyName', width: 30, type: 'string' },
        { header: i18next.t('field.ref_no'), key: 'refNo1', width: 60, type: 'string' },
        { header: i18next.t('field.ref_no_2'), key: 'refNo2', width: 60, type: 'string' },
        { header: i18next.t('field.ref_no_3'), key: 'refNo3', width: 60, type: 'string' },
        { header: i18next.t('field.loose_item'), key: 'looseItem', width: 20, type: 'string' },
        { header: i18next.t('field.container_no'), key: 'containerNo', width: 30, type: 'string' },
        { header: i18next.t('field.container_size'), key: 'containerSize', width: 30, type: 'string' },
        { header: i18next.t('field.own_transport'), key: 'ownTransport', width: 20, type: 'string' },
        { header: i18next.t('field.order_created_by'), key: 'orderCreatedBy', width: 30, type: 'string' },
        { header: i18next.t('field.order_created_at'), key: 'orderCreatedAt', width: 30, type: 'string' },
        { header: i18next.t('field.unload_start'), key: 'unloadStart', width: 30, type: 'string' },
        { header: i18next.t('field.unload_complete'), key: 'unloadComplete', width: 30, type: 'string' },
        { header: i18next.t('field.putaway_start'), key: 'putawayStart', width: 30, type: 'string' },
        { header: i18next.t('field.putaway_complete'), key: 'putawayComplete', width: 30, type: 'string' },
        { header: i18next.t('field.accepted_by'), key: 'acceptedBy', width: 30, type: 'string' },
        { header: i18next.t('field.accepted_at'), key: 'acceptedAt', width: 30, type: 'string' },
        { header: i18next.t('field.line_no'), key: 'orderLineItem', width: 15, type: 'int' },
        { header: i18next.t('field.sku'), key: 'product|sku', width: 25, type: 'string' },
        { header: i18next.t('field.product_name'), key: 'product|name', width: 50, type: 'string' },
        { header: i18next.t('field.product_description'), key: 'product|description', width: 50, type: 'string' },
        { header: i18next.t('field.product_type'), key: 'product|type', width: 30, type: 'string' },
        { header: i18next.t('field.packing_type'), key: 'packType', width: 25, type: 'string' },
        { header: i18next.t('field.packing_size'), key: 'packSize', width: 25, type: 'string' },
        { header: i18next.t('field.qty'), key: 'actualPackQty', width: 15, type: 'string' },
        { header: i18next.t('field.uom_value'), key: 'actualPackUomValue', width: 15, type: 'string' },
        { header: i18next.t('field.uom'), key: 'uom', width: 15, type: 'string' },
        { header: i18next.t('field.type_of_condition'), key: 'conditionOfGoods', width: 25, type: 'string' },
        { header: i18next.t('field.unit_cost'), key: 'unitCost', width: 15, type: 'string' },
        { header: i18next.t('field.unit_volume'), key: 'unitVolume', width: 15, type: 'string' },
        { header: i18next.t('field.total_volume'), key: 'totalVolume', width: 15, type: 'string' },
        { header: i18next.t('field.unit_nett_weight'), key: 'unitNettWeight', width: 15, type: 'string' },
        { header: i18next.t('field.total_unit_nett_weight'), key: 'totalUnitNettWeight', width: 15, type: 'string' },
        { header: i18next.t('field.unit_gross_weight'), key: 'unitGrossWeight', width: 15, type: 'string' },
        { header: i18next.t('field.total_unit_gross_weight'), key: 'totalUnitGrossWeight', width: 15, type: 'string' },
        { header: i18next.t('field.weight_unit'), key: 'weightUnit', width: 15, type: 'string' },
        { header: i18next.t('field.lot_id'), key: 'palletId', width: 25, type: 'string' },
        { header: i18next.t('field.carton_id'), key: 'cartonId', width: 25, type: 'string' },
        { header: i18next.t('field.batch_id'), key: 'batchId', width: 25, type: 'string' },
        { header: i18next.t('field.batch_id_ref'), key: 'batchIdRef', width: 25, type: 'string' },
        { header: i18next.t('field.unloaded_by'), key: 'unloadedBy', width: 30, type: 'string' },
        { header: i18next.t('field.unloaded_at'), key: 'unloadedAt', width: 15, type: 'string' },
        { header: i18next.t('field.exp_date'), key: 'expirationDate', width: 15, type: 'string' },
        { header: i18next.t('field.manufacture_date'), key: 'manufactureDate', width: 15, type: 'string' },
        { header: i18next.t('field.putaway_by'), key: 'putawayBy', width: 15, type: 'string' },
        { header: i18next.t('field.putaway_at'), key: 'putawayAt', width: 15, type: 'string' }
      ]

      var exportData = {
        header: [...headerSetting],
        data: (await this.fetchHandler({ page: 1, limit: 9999999 })).records.map(itm => {
          return {
            ...itm,
            orderCreatedAt: itm.orderCreatedAt ? new Date(parseInt(itm.orderCreatedAt)).toLocaleString() : '',
            unloadStart: itm.unloadStart ? new Date(parseInt(itm.unloadStart)).toLocaleString() : '',
            unloadComplete: itm.unloadComplete ? new Date(parseInt(itm.unloadComplete)).toLocaleString() : '',
            putawayStart: itm.putawayStart ? new Date(parseInt(itm.putawayStart)).toLocaleString() : '',
            putawayComplete: itm.putawayComplete ? new Date(parseInt(itm.putawayComplete)).toLocaleString() : '',
            acceptedAt: itm.acceptedAt ? new Date(parseInt(itm.acceptedAt)).toLocaleString() : '',
            unloadedAt: itm.unloadedAt ? new Date(parseInt(itm.unloadedAt)).toLocaleString() : '',
            putawayAt: itm.putawayAt ? new Date(parseInt(itm.putawayAt)).toLocaleString() : '',
            expirationDate: itm.expirationDate ? new Date(parseInt(itm.expirationDate)).toLocaleString() : '',
            manufactureDate: itm.manufactureDate ? new Date(parseInt(itm.manufactureDate)).toLocaleString() : ''
          }
        })
      }

      return exportData
    } catch (e) {
      this._showToast(e)
    }
  }

  _formatConditionOfGoods(conditionValue) {
    if (!conditionValue) return null
    
    const conditionKey = Object.keys(CONDITION_OF_GOODS).find(
      key => CONDITION_OF_GOODS[key].value === conditionValue
    )
    
    if (conditionKey) {
      return i18next.t(`label.${CONDITION_OF_GOODS[conditionKey].name}`)
    }
    
    return conditionValue
  }

  _showToast({ type, message }) {
    document.dispatchEvent(
      new CustomEvent('notify', {
        detail: {
          type,
          message
        }
      })
    )
  }
}

window.customElements.define('inbound-order-details-report', InboundOrderDetailsReport)
